import datetime
import logging
import time
import requests

from pymemri.pod.client import PodClient
from pymemri.data.itembase import Edge
from pymemri.data.schema import Account
from pymemri.data.photo import Photo

from whatsapp.schema import Message


logging.basicConfig(level=logging.INFO)
logger = logging.getLogger(__name__)


client = PodClient(
    owner_key="0077092be5b1403f833e13fde64201bd62b63ca6451d49668634bac3cc8ec5fa",
    database_key="539502a379cb4992891aab94e767268a646bb0a4fb5b40e2a9ad19bd470249d1",
)

def create_or_get(type_, **kwargs):
    item = type_(service='whatsapp', **kwargs)
    items = client.search({'type' : type_.__name__, **kwargs})
    if items:
        logger.info("Found %s", items)
        return items[0]
    else:
        logger.info("Creating %s",  item)
        client.create(item)
        return item

edges = []
items = []

def register_message(sender, receiver, channel, content):
    msg = Message(service='whatsapp', content=content,
                          dateSent=datetime.datetime.now())
    items.append(msg)
    edges.append(Edge(msg, channel, 'messageChannel'))
    edges.append(Edge(msg, sender, 'sender'))
    edges.append(Edge(msg, receiver, 'receiver'))

    time.sleep(0.001)

def save_messages():
    client.bulk_action(create_edges=edges, create_items=items)
    edges.clear()
    items.clear()

def search(type_, **kwargs):
    return client.search({'type' : type_.__name__, **kwargs})



def add_photo(user : Account, url : str, force:bool=False):
    if user.profilePicture and not force:
        logger.info("User %s already has a profile picture", user)
        return
    image_bytes = requests.get(url).content
    photo = Photo.from_bytes(image_bytes)
    # client._upload_image(photo.data, asyncFlag=False)
    client.create_photo(photo)
    edge = Edge(user, photo, 'profilePicture')
    client.bulk_action(create_items=[], create_edges=[edge])

